Index: /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs	(revision 14790)
+++ /trunk/sources/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs	(revision 14791)
@@ -463,4 +463,9 @@
     }
 
+	public bool StatisticsVisible {
+		get { return splitContainer.Panel2Collapsed; }
+		set { splitContainer.Panel2Collapsed = value; }
+	}
+	
     public void SetXAxis(string axisName) {
       xAxisComboBox.SelectedItem = axisName;
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs	(revision 14790)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF3.cs	(revision 14791)
@@ -41,12 +41,12 @@
     protected override string[] AllowedInputVariables {
       get { return new string[] { /* "Material_Cat", */
-        "Source1", "Source2", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        /*"Source1", "Source2",*/ "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
         /* "Material", "Grooving", "Oil", */                                           
-        "x17", "x18", "x19", "x20", "x21", "x22" }; }
+        "x17", "x22" }; }
     }
     protected override int TrainingPartitionStart { get { return 0; } }
-    protected override int TrainingPartitionEnd { get { return 9999; } }
-    protected override int TestPartitionStart { get { return 9999; } }
-    protected override int TestPartitionEnd { get { return 9999; } }
+    protected override int TrainingPartitionEnd { get { return 441; } }
+    protected override int TestPartitionStart { get { return 441; } }
+    protected override int TestPartitionEnd { get { return 657; } }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs	(revision 14790)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/CF4.cs	(revision 14791)
@@ -41,12 +41,12 @@
     protected override string[] AllowedInputVariables {
       get { return new string[] { /* "Material_Cat", */
-        "Source1", "Source2", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
         /* "Material", "Grooving", "Oil", */                                           
-        "x17", "x18", "x19", "x20", "x21", "x22" }; }
+        "x17", "x22" }; }
     }
     protected override int TrainingPartitionStart { get { return 0; } }
-    protected override int TrainingPartitionEnd { get { return 9999; } }
-    protected override int TestPartitionStart { get { return 9999; } }
-    protected override int TestPartitionEnd { get { return 9999; } }
+    protected override int TrainingPartitionEnd { get { return 437; } }
+    protected override int TestPartitionStart { get { return 437; } }
+    protected override int TestPartitionEnd { get { return 649; } }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs	(revision 14790)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/NvhRating.cs	(revision 14791)
@@ -41,12 +41,12 @@
     protected override string[] AllowedInputVariables {
       get { return new string[] { /* "Material_Cat", */
-        "Source1", "Source2", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
         /* "Material", "Grooving", "Oil", */                                           
-        "x17", "x18", "x19", "x20", "x21", "x22" }; }
+        "x17", "x18", "x19", "x21", "x22" }; }
     }
     protected override int TrainingPartitionStart { get { return 0; } }
-    protected override int TrainingPartitionEnd { get { return 9999; } }
-    protected override int TestPartitionStart { get { return 9999; } }
-    protected override int TestPartitionEnd { get { return 9999; } }
+    protected override int TrainingPartitionEnd { get { return 2636; } }
+    protected override int TestPartitionStart { get { return 2636; } }
+    protected override int TestPartitionEnd { get { return 3943; } }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs	(revision 14790)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp1.cs	(revision 14791)
@@ -41,12 +41,12 @@
     protected override string[] AllowedInputVariables {
       get { return new string[] { /* "Material_Cat", */
-        "Source1", "Source2", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
         /* "Material", "Grooving", "Oil", */                                           
-        "x17", "x18", "x19", "x20", "x21", "x22" }; }
+        "x17", "x22" }; }
     }
     protected override int TrainingPartitionStart { get { return 0; } }
-    protected override int TrainingPartitionEnd { get { return 9999; } }
-    protected override int TestPartitionStart { get { return 9999; } }
-    protected override int TestPartitionEnd { get { return 9999; } }
+    protected override int TrainingPartitionEnd { get { return 440; } }
+    protected override int TestPartitionStart { get { return 440; } }
+    protected override int TestPartitionEnd { get { return 656; } }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs	(revision 14790)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Temp2.cs	(revision 14791)
@@ -41,12 +41,12 @@
     protected override string[] AllowedInputVariables {
       get { return new string[] { /* "Material_Cat", */
-        "Source1", "Source2", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        "x1", "x2", "x3", "x4", "x5", "x6", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
         /* "Material", "Grooving", "Oil", */                                           
-        "x17", "x18", "x19", "x20", "x21", "x22" }; }
+        "x17", "x22" }; }
     }
     protected override int TrainingPartitionStart { get { return 0; } }
-    protected override int TrainingPartitionEnd { get { return 9999; } }
-    protected override int TestPartitionStart { get { return 9999; } }
-    protected override int TestPartitionEnd { get { return 9999; } }
+    protected override int TrainingPartitionEnd { get { return 437; } }
+    protected override int TestPartitionStart { get { return 437; } }
+    protected override int TestPartitionEnd { get { return 648; } }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs	(revision 14790)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear1.cs	(revision 14791)
@@ -41,12 +41,12 @@
     protected override string[] AllowedInputVariables {
       get { return new string[] { /* "Material_Cat", */
-        "Source1", "Source2", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        "Source1", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
         /* "Material", "Grooving", "Oil", */                                           
         "x17", "x18", "x19", "x20", "x21", "x22" }; }
     }
     protected override int TrainingPartitionStart { get { return 0; } }
-    protected override int TrainingPartitionEnd { get { return 9999; } }
-    protected override int TestPartitionStart { get { return 9999; } }
-    protected override int TestPartitionEnd { get { return 9999; } }
+    protected override int TrainingPartitionEnd { get { return 641; } }
+    protected override int TestPartitionStart { get { return 641; } }
+    protected override int TestPartitionEnd { get { return 904; } }
   }
 }
Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs	(revision 14790)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis/3.3/Regression/MibaFriction/Wear2.cs	(revision 14791)
@@ -41,12 +41,12 @@
     protected override string[] AllowedInputVariables {
       get { return new string[] { /* "Material_Cat", */
-        "Source1", "Source2", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
+        "Source1", "x1", "x2", "x3", "x4", "x5", "x6", "x7", "x8", "x9", "x10", "x11", "x12", "x13", "x14", "x15", "x16",
         /* "Material", "Grooving", "Oil", */                                           
         "x17", "x18", "x19", "x20", "x21", "x22" }; }
     }
     protected override int TrainingPartitionStart { get { return 0; } }
-    protected override int TrainingPartitionEnd { get { return 9999; } }
-    protected override int TestPartitionStart { get { return 9999; } }
-    protected override int TestPartitionEnd { get { return 9999; } }
+    protected override int TrainingPartitionEnd { get { return 640; } }
+    protected override int TestPartitionStart { get { return 640; } }
+    protected override int TestPartitionEnd { get { return 902; } }
   }
 }